////////////////////////////////////////////////////////////////////////
//
//      Quinn Jacobson (qjacobso@ece.wisc.edu)
//      ECE department U of Wisconsin
//
//      CS 701
//      Feb 1996
//
//      LocalVars.h
//
////////////////////////////////////////////////////////////////////////
//
// Code to maintain information about local variables.
//
////////////////////////////////////////////////////////////////////////

int LVdata_size(char *name);
// Returns the size of local variable

int LVoffset(char *name);
// Returns offset for a local variable/incoming parameter
//	0 if not a local variable or parameter
//	negative offset (relative to fp) is Local variable
// 	positive offset (relative to fp) is parameter

void LVreset();
// Reset Local Variable data structures 

void LVparam(const char *name, int size);
// enter a incoming parameter 

void LVvar(const char *name, int size);
// enter a local variable 
// if the same name has not already been entered as a incoming parameter

int LVvarSize();
// return the size of the local variable space on the stack

//------ FUNCTIONS FOR REGISTER ALLOCATION -----

int LVidentify(char *name, struct candi_node *candi, int candi_num);
// Identify a local variable as a register allocataion candidate.
// Associate the structure pointed to by candi with the variable.
// Return the offset already associated with the variable.

struct candi_node* LValloc(char *name);
// Returns a pointer to the allocation structure for a local variable
// if it has been identified as a candidate for register allocation, else NULL

int LVcandi_num(char *name);
// Returns the candi_num
// if it has been identified as a candidate for register allocation, else -1

//---------- LV functions for Loop invariants ----------

int LVnum(char *s);
// return the unique number associated with var/param s
// return 0 if not present


void LVset_def_in(char *s, int block);
// tag var s as being defed in block

int LVdef_in(char *s);
// return the def_in number associated with var/param s
// return 0 if not present
