////////////////////////////////////////////////////////////////////////
//
//      Quinn Jacobson (qjacobso@ece.wisc.edu)
//      ECE department U of Wisconsin
//
//      CS 701
//      April 1996
//
//      instr.h
//
////////////////////////////////////////////////////////////////////////
//
// instr interface
//
////////////////////////////////////////////////////////////////////////
 
#include "instr_type.h"

//----- FUNCTION PROTOTYPES ------
void instr_init();

s_instr* new_instr(int opcode);

s_operand *new_operand();

s_operand *zero_operand();

s_operand *reg_operand(int reg_num);

s_operand *jump_target(char *target, char* proc_name);

s_operand *quinn_label(char *target, char* quinn_num);

s_operand *fp_offset_operand(int offset);

s_operand *sp_offset_operand(int offset);

s_operand *immed_operand(int immed);

s_operand *simple_address(int reg, int offset);

s_operand *hi_operand(char *label, int immed);

s_operand *lo_operand(char *label, int immed);

s_operand *call_target(char *label);

s_operand *label_string(char *target, char* proc_name);

s_operand *src_operand(int src);

s_operand *address_operand(int src, char *p);

void build_vectors();


