/************************************************************************
 * main.cc: Main program for Simple-SUIF code-generator.
 *
 * main() initializes the SUIF library and compiles the input SUIF file
 * (sending the output to "/dev/null").
 * The generated assembly code should go to stdout.
 *
 * This file does not need to change.
************************************************************************/

#include <iostream.h>
#include "codegen.h"

extern void init_suif(int &, char **); // these two come from SUIF
extern void compile(char *, char *);

const char* prog_who_string = "(me)"; // these two are required by SUIF
const char* prog_ver_string = "0.0";

int	ARG_post = 0;
bool aggressive;
int      special_temp = 0;
int	do_loop_inv = 0;
bool alloc;
bool reportAlloc;

int main(int argc, char** argv) {
    int i;

    aggressive = false;
    alloc = false;
    if (argc < 2) {
        cerr << "Usage: " << argv[0] << " suif-file" << endl;
        return -1;
    }
    for (i = 2; i < argc; i++)
    {
	if (!strcmp(argv[i],"-post"))
	    ARG_post = 1;
	if (!strcmp(argv[i],"-aggr"))
 	    aggressive = true;
	if (!strcmp(argv[i],"-temp"))
 	    special_temp = 1;
	if (!strcmp(argv[i],"-loop"))
 	    do_loop_inv = 1;
  if (!strcmp(argv[i],"-alloc"))
      alloc = true;
  if (!strcmp(argv[i],"-reportAlloc"))
      reportAlloc = true;
    }

    init_suif(argc, argv);
    codegen_init();
    compile(argv[1], "/dev/null");
    codegen_finish();

    return 0;
}
