////////////////////////////////////////////////////////////////////////
//
//      Quinn Jacobson (qjacobso@ece.wisc.edu)
//      ECE department U of Wisconsin
//
//      CS 701
//      Feb 1996
//
//      operand.h
//
////////////////////////////////////////////////////////////////////////
//
// Handles Operands
//
// UPDATED: to recognize machine registers as operands
//
////////////////////////////////////////////////////////////////////////

int getDST(int is_load, simple_reg *dst);
// Arrange for a destination operand

void printDST(int dst);
// Print a destination operand

int addressSRC(simple_reg *src, char **sym);
// Arrange for an address operand

void printAddress(int addr, char *sym);
// Print an Address operand

int RegSRC(simple_reg *src, int work);
// Arrange for a source operand that has to be a register.

int RegImmedSRC(simple_reg *src, int work);
// Arrange for a source operand that can be an operand or a small constant
// In the case of FLOATING POINT the operand must be in a register

void printSRC (int src);
// Print a source operand

int CallTarget(simple_reg *src, char **sym);
// Arrange for a call target
// If the target is a symbol, *sym will be set to the name and -1 returned
// Else a register value will be returned

REGnode *getreg(TEMPnode *temp, int is_load);
// get a integer type register for temp temp

