/************************************************************************
 * ss_symtab.h: symbol tables for Simple-SUIF
************************************************************************/





#if !defined(_ss_symtab_h_)
#define _ss_symtab_h_





#if defined(__cplusplus)
extern "C" {
#endif /* defined(__cplusplus) */





/************************************************************************
 * header files.
************************************************************************/

#include <simple.h>





/************************************************************************
 * types.
************************************************************************/

struct ss_symbol {
    const char* sym_name;
    unsigned    sym_size;
    unsigned    sym_align;
    int         is_defined;
    int         is_aggregate;
};





/************************************************************************
 * variables.
************************************************************************/

extern struct ss_symbol* ss_global_syms;
extern unsigned          ss_global_nsyms;





/************************************************************************
 * functions.
************************************************************************/

extern unsigned                get_referrent_size(const simple_reg *);

extern const struct ss_symbol* ss_proc_syms(const char *);
extern unsigned                ss_proc_nsyms(const char *);

extern const struct ss_symbol* ss_proc_params(const char *);
extern unsigned                ss_proc_nparams(const char *);





#if defined(__cplusplus)
};
#endif /* defined(__cplusplus) */





#endif /* !defined(_ss_symtab_h_) */
