////////////////////////////////////////////////////////////////////////
//
//      Quinn Jacobson (qjacobso@ece.wisc.edu)
//      ECE department U of Wisconsin
//
//      CS 701
//      Feb 1996
//
//      temp.h
//
////////////////////////////////////////////////////////////////////////
//
// Temporary mapping
//
////////////////////////////////////////////////////////////////////////

typedef struct TEMPnode
{
    int         temp;
    int		fp;	// 0:integer, 1:fp
    int         type;   // 0:invalid, 1:immed, 2:reg, 3:upper in reg & low immed
			// 4: fp & offset, 5: reg & sym, 6: sym
			// 7: sp & offset
    int         immed;
    int         size;
    char	*sym;
    struct REGnode *reg;
    struct TEMPnode *next;
    struct TEMPnode *prev;
} TEMPnode;
 
void TEMPinit();
// Initialize temp data structures

void TEMPreset();
// Reset temp data structures at the begining of processing a function

TEMPnode* findTEMP(int temp);
// Return a pointer to the TEMPnode associated with TEMP_REG # temp

void removeTEMP(TEMPnode *tptr);
// Remove a TEMPnode that has been used

TEMPnode* newTEMP(int temp);
// allocate a new TEMPnode to be associated with the TEMP_REG # temp

