




extern	struct	_iobuf {
	int	_cnt;
	unsigned char *_ptr;
	unsigned char *_base;
	int	_bufsiz;
	short	_flag;
	char	_file;		
} _iob[];






























extern struct _iobuf	*fopen();
extern struct _iobuf	*fdopen();
extern struct _iobuf	*freopen();
extern struct _iobuf	*popen();
extern struct _iobuf	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
extern char	*sprintf();
extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();
















fatal(char *msg)
{
    fprintf((&_iob[2]),"ERROR: %s\n",msg);
    exit(1);
}





typedef short unsigned boolean;






















typedef struct symtabEntryBody *symtabEntry;

symtabEntry CreateSymtabEntry(char *name, int num1, int num2);
symtabEntry EmptySymtabEntry();
char *EName(symtabEntry t);
int ENum1(symtabEntry t);
int ENum2(symtabEntry t);

















typedef struct listBody *list;

list CreateList();
symtabEntry CurrentList(list L);
boolean AtEndList(list L);
















































typedef struct listItem *listItemPtr;

struct listItem {symtabEntry  _info;
		 listItemPtr  _next;
		 };

struct listBody {listItemPtr  _first,_last,_current;
		 };




list CreateList()
{
list L;

    L = (list)malloc(sizeof(struct listBody));
    L->_first = ((listItemPtr)(+1));
    L->_last = ((listItemPtr)(+1));
    L->_current = ((listItemPtr)(+1));
    return(L);
}





boolean AtEndList(list L)
{
    return(L->_current == ((listItemPtr)(+1)));
}







symtabEntry CurrentList(list L)
{
    if (AtEndList(L)) {
        printf("ERROR: attempt to access non-existent 'current' item");
        return(EmptySymtabEntry());
	}
    else return((L->_current)->_info);
}





AddToList(list L, char * name, int num1, int num2)
{
listItemPtr tmpItem;
symtabEntry tmpInfo;

    tmpInfo = CreateSymtabEntry(name, num1, num2);
    tmpItem = (listItemPtr)malloc(sizeof(struct listItem));
    tmpItem->_info = tmpInfo;
    tmpItem->_next = ((listItemPtr)(+1));
    if (L->_last != ((listItemPtr)(+1))) (L->_last)->_next = tmpItem;
    L->_last = tmpItem;
    if (L->_first == ((listItemPtr)(+1))) L->_first = tmpItem;
}









RemoveFromList(list L, char *name)
{
boolean found;
symtabEntry tmp;
listItemPtr previous;
    found = (0);
    previous = ((listItemPtr)(+1));
    ResetList(L);
    while ((! AtEndList(L)) && (! found)) {
        tmp = CurrentList(L);
	if (strcmp(EName(tmp),name) == 0) {
	    found = (1);
	    if (previous == ((listItemPtr)(+1))) L->_first = L->_current->_next;
	    else previous->_next = L->_current->_next;

	    if (L->_last == L->_current) L->_last = previous;
	    L->_current = L->_current->_next;
	  }
	else { 
	    previous = L->_current;
	    NextList(L);
	  }
      }
    if (! found) printf("ERROR: attempt to remove nonexistent item from list\n");
}






ResetList(list L)
{
    L->_current = L->_first;
}






NextList(list L)
{
    if (AtEndList(L)) printf("ERROR: attempt to move 'current' past end of list");
    else L->_current = (L->_current)->_next;
}





PrintList(list L)
{
symtabEntry info;

    ResetList(L);
    while (! AtEndList(L)) {
	info = CurrentList(L);
	PrintSymtabEntry(info);
	NextList(L);
        }
}



































extern struct _iobuf	*fopen();
extern struct _iobuf	*fdopen();
extern struct _iobuf	*freopen();
extern struct _iobuf	*popen();
extern struct _iobuf	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
extern char	*sprintf();
extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();

























symtabEntry CreateSymtabEntry(char *name, int num1, int num2);
symtabEntry EmptySymtabEntry();
char *EName(symtabEntry t);
int ENum1(symtabEntry t);
int ENum2(symtabEntry t);
















typedef struct hashtabBody *symtab;

symtab CreateSymtab();
symtab Insert();
symtab Delete();
symtab UpdateOffset();
symtabEntry Lookup();






























list CreateList();
symtabEntry CurrentList(list L);
boolean AtEndList(list L);



















char * ReadlnStr();










main()
{
symtab s;
char *s1;
char *s2;
char *name;
int i, idtype, offset, n1, n2;
char c, ret;
list L;
symtabEntry e;

L = CreateList();
s = CreateSymtab();
printf("1 = test lists, 2 = test symbol tables:");
scanf("%d",&i);
scanf("%c",&ret); 
if (i == 1)

for (;;) {
    printf("0 = quit\n");
    printf("1 = add to list\n");
    printf("2 = remove from list\n");
    printf("3 = current item\n");
    printf("4 = reset\n");
    printf("5 = next?\n");
    printf("6 = at end\n");
    printf("7 = print list: ");
    scanf("%d",&i);
    scanf("%c",&ret); 
    if (i == 1) {
        printf("enter name: ");
	name = ReadlnStr((&_iob[0]));
	printf("enter num1: ");
	scanf("%d",&n1);
        scanf("%c",&ret); 
	printf("enter num2: ");
	scanf("%d",&n2);
        scanf("%c",&ret); 
	AddToList(L, name, n1,n2);
      }
    else if (i == 2) {
        printf("enter name: ");
	name = ReadlnStr((&_iob[0]));
	printf("enter num1: ");
	RemoveFromList(L,name);
    }
    else if (i == 3) {
        e = CurrentList(L);
	if (e != EmptySymtabEntry()) { PrintSymtabEntry(e);}
    }
    else if (i == 4) {
        ResetList(L);
    }
    else if (i == 5) {
        NextList(L);
    }
    else if (i == 6) {
        if (AtEndList(L)) {printf("TRUE\n");}
	else {printf("FALSE\n");}
    }
    else if (i == 7) {
        PrintList(L);
    }
    else break;
  }
else {for (;;) {
    printf("0 = quit\n");
    printf("1 = lookup,\n");
    printf("2 = insert,\n");
    printf("3 = delete,\n");
    printf("4 = update offset\n");
    printf("5 = print symtab: ");
    scanf("%d",&i);
    scanf("%c",&ret); 
    if (i == 1) {
        printf("enter name: ");
	name = ReadlnStr((&_iob[0]));
        e = Lookup(s,name);
	if (e == (symtabEntry)(+1)) printf("name not in symtab\n");
	else PrintSymtabEntry(e);
        } 
    else if (i == 2) {
        printf("enter name: ");
	name = ReadlnStr((&_iob[0]));
	printf("enter type: ");
	scanf("%d", &idtype);
	printf("enter offset: ");
	scanf("%d", &offset);
        s = Insert(s,name,idtype,offset);
        } 
    else if (i == 3) {
	printf("enter name: \n");
	name = ReadlnStr((&_iob[0]));
	s = Delete(s, name);
        } 
    else if (i == 4) {
        printf("enter name: \n");
	name = ReadlnStr((&_iob[0]));
	printf("enter new offset: ");
	scanf("%d", &offset);
        s = UpdateOffset(s,name,offset);
	} 
    else if (i == 5) {
        PrintSymtab(s);
        } 
    else break;
  }
    }
}




































extern struct _iobuf	*fopen();
extern struct _iobuf	*fdopen();
extern struct _iobuf	*freopen();
extern struct _iobuf	*popen();
extern struct _iobuf	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
extern char	*sprintf();
extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();

























typedef	int		sigset_t;	

typedef	unsigned int	speed_t;	
typedef	unsigned long	tcflag_t;	
typedef	unsigned char	cc_t;		
typedef	int		pid_t;		

typedef	unsigned short	mode_t;		
typedef	short		nlink_t;	

typedef	long		clock_t;	
typedef	long		time_t;		

typedef	int		size_t;		
typedef int		ptrdiff_t;	

typedef	unsigned short	wchar_t;	






extern char *	strcat();
extern char *	strchr();
extern int	strcmp();
extern char *	strcpy();
extern size_t	strcspn();

extern char *	strdup();

extern size_t	strlen();
extern char *	strncat();
extern int	strncmp();
extern char *	strncpy();
extern char *	strpbrk();
extern char *	strrchr();
extern size_t	strspn();
extern char *	strstr();
extern char *	strtok();

























char * ReadlnStr();




































char * ReadlnStr(struct _iobuf *infile)
{
int curr_size;
char *tmp;
boolean done;
int i;
char c;

    curr_size = 10;
    tmp = (char *)malloc(10);
    done = (0);
    i = 0;
    while (!done) {
	while ((i<curr_size-1) && ((c=(--(infile)->_cnt>=0? ((int)*(infile)->_ptr++):_filbuf(infile))) !=(-1) && c != '\n')) {
	    tmp[i] = c;
	    i++;
	    }
	if (c=='\n' || c==(-1)) {
	    


	    tmp[i] = '\0';
	    i++;
	    done = (1);
	    }
	else { 


		curr_size = curr_size*2;
	        tmp = (char *)realloc(tmp, curr_size);
	        if (tmp == 0) fatal("realloc failed in ReadlnStr");
	     }
        }
    return(tmp);
}



















symtabEntry CreateSymtabEntry(char *name, int num1, int num2);
symtabEntry EmptySymtabEntry();
char *EName(symtabEntry t);
int ENum1(symtabEntry t);
int ENum2(symtabEntry t);

















symtab CreateSymtab();
symtab Insert();
symtab Delete();
symtab UpdateOffset();
symtabEntry Lookup();






























list CreateList();
symtabEntry CurrentList(list L);
boolean AtEndList(list L);





















































struct hashtabBody {list _hashtab[11];};


symtab CreateSymtab()
{
symtab tmp;
int i;

    tmp = (symtab)malloc(sizeof(struct hashtabBody));
    for (i = 0; i< 11; i++) {
        (tmp->_hashtab)[i] = CreateList();
      }
    return(tmp);
}

symtabEntry Lookup(symtab s, char *name)
{
int i;
boolean found;
symtabEntry e;

    i = Hash(name);
    ResetList((s->_hashtab)[i]);
    found = (0);
    while ((! AtEndList((s->_hashtab)[i])) && (! found)) {
        e = CurrentList((s->_hashtab)[i]);
	if (strcmp(EName(e), name) == 0) found = (1);
	else NextList((s->_hashtab)[i]);
      }
    if (! found) return((symtabEntry)(+1));
    else return(e);
}

symtab Insert(symtab s, char *name, int idtype, int offset)
{
int i;

    if (Lookup(s, name) == (symtabEntry)(+1)) {
        i = Hash(name);
        AddToList((s->_hashtab)[i], name, idtype, offset);
      }
    else Warn("Attempt to insert duplicate name into symbol table");
    return(s);
}

symtab Delete(symtab s, char *name)
{
list L;

    if (Lookup(s, name) == (symtabEntry)(+1)) {
        Warn("Attempt to delete non-existent name from symbol table");
	return(s);
      }
    else {
        L = (s-> _hashtab)[Hash(name)];
	RemoveFromList(L, name);
	return(s);
      }
}

symtab UpdateOffset(symtab s, char *name, int offset)
{
symtabEntry e;

    e = Lookup(s, name);
    if (e == (symtabEntry)(+1)) {
        Warn("Attempt to update non-existent entry");
	return(s);
      }
    else {
        s = Delete(s,name);
	return(Insert(s,name,ENum1(e),offset));
      }
}

PrintSymtab(symtab s)
{
int i;

    for (i = 0;  i < 11; i++) {
        PrintList((s->_hashtab)[i]);
      }
}

int Hash(char *name)
{
    if (strlen(name) == 0) {
        Warn("Bad name passed to hash function");
	return(1);
      }
    else return(1);
}

Warn(char *s)
{
    printf("WARNING: %s\n", s);
  }


















symtabEntry CreateSymtabEntry(char *name, int num1, int num2);
symtabEntry EmptySymtabEntry();
char *EName(symtabEntry t);
int ENum1(symtabEntry t);
int ENum2(symtabEntry t);































struct symtabEntryBody {char * _name;
		        int _num1, _num2;
       		        };





symtabEntry CreateSymtabEntry(char * name, int num1, int num2)
{
symtabEntry e;

    e = (symtabEntry)malloc(sizeof(struct symtabEntryBody));
    e->_name = (char *)malloc(strlen(name)+1);
    strcpy(e->_name,name);
    e->_num1 = num1;
    e->_num2 = num2;
    return(e);
}




symtabEntry EmptySymtabEntry()
{
    return(((symtabEntry)(+1)));
}





char * EName(symtabEntry e)
{
    if (e == ((symtabEntry)(+1))) {
        printf("ERROR: attempt to access empty symtabEntry in function EName");
	return("");
	}
    else return(e->_name);
}





int ENum1(symtabEntry e)
{
    if (e == ((symtabEntry)(+1))) {
        printf("ERROR: attempt to access empty symtabEntry in function ENum1");
	return(0);
	}
    else return(e->_num1);
}





int ENum2(symtabEntry e)
{
    if (e == ((symtabEntry)(+1))) {
        printf("ERROR: attempt to access empty symtabEntry in function ENum2");
	return(0);
	}
    else return(e->_num2);
}





PrintSymtabEntry(symtabEntry e)
{
    printf("%s,  %d,  %d\n", e->_name, e->_num1, e->_num2);
  }

